import Test.HUnit
import PathUtils

main = runTestTT $ test $
    [ "test_ancestors"  ~: test_ancestors,
      "test_components" ~: test_components,
      "test_concatPath" ~: test_concatPath,
      "test_joinPath"   ~: test_joinPath,
      "test_basename"   ~: test_basename,
      "test_dirname"    ~: test_dirname ]

test_ancestors =
    do assertEqual "1" ["/"] (ancestors "/")
       assertEqual "2" ["/a", "/"] (ancestors "/a")
       assertEqual "3" ["/a/b", "/a", "/"] (ancestors "/a/b")
       assertEqual "4" ["/a/b", "/a", "/"] (ancestors "/a/b/")
       assertEqual "5" ["a/b", "a"] (ancestors "a/b")
       assertEqual "6" ["a/b", "a"] (ancestors "a/b/")
       assertEqual "7" ["a"] (ancestors "a")

test_components =
    do assertEqual "1" [""] (components "/")
       assertEqual "2" ["", "a"] (components "/a")
       assertEqual "3" ["", "a", "b"] (components "/a/b")
       assertEqual "4" ["", "a", "b"] (components "/a/b/")
       assertEqual "5" ["a", "b"] (components "a/b")
       assertEqual "6" ["a", "b"] (components "a/b/")

test_concatPath =
    do assertEqual "1" "/" (concatPath [])
       assertEqual "2" "/" (concatPath [""])
       assertEqual "3" "/" (concatPath ["/"])
       assertEqual "4" "/a" (concatPath ["", "a"])
       assertEqual "5" "/a/b" (concatPath ["", "a", "b"])

test_joinPath =
    do assertEqual "1" "/a" (joinPath "/" "a")
       assertEqual "2" "/a/b" (joinPath "/a" "b")
       assertEqual "3" "a/b" (joinPath "a" "b")

test_basename =
    do assertEqual "1" "/" (basename "/")
       assertEqual "2" "a" (basename "/a")
       assertEqual "3" "b" (basename "/a/b")
       assertEqual "4" "a" (basename "a")
       assertEqual "5" "b" (basename "a/b")
       assertEqual "6" "." (basename ".")
       assertEqual "7" ".." (basename "..")

test_dirname =
    do assertEqual "1" "/" (dirname "/")
       assertEqual "2" "/" (dirname "/a")
       assertEqual "3" "/a" (dirname "/a/b")
       assertEqual "4" "/a/b" (dirname "/a/b/c")
       assertEqual "5" "a" (dirname "a/b")
       assertEqual "6" "." (dirname "a")
       assertEqual "7" "." (dirname ".")
       assertEqual "8" "." (dirname "..")
